#include "stm32f10x.h"
#include "io_mlp101c.h"


#define POWER_ON_PIN          GPIO_Pin_0
#define POWER_ON_GPIO_PORT         GPIOB
#define POWER_ON_GPIO_CLK     RCC_APB2Periph_GPIOB

#define FB_PO6_PIN          GPIO_Pin_1
#define FB_PO6_GPIO_PORT         GPIOB
#define FB_PO6_GPIO_CLK     RCC_APB2Periph_GPIOB

void io_init(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable GPIO clock */
  RCC_APB2PeriphClockCmd(POWER_ON_GPIO_CLK | FB_PO6_GPIO_CLK, ENABLE);

  /* Configure POWER_ON in Output Push-Pull mode */
  GPIO_InitStructure.GPIO_Pin = POWER_ON_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(POWER_ON_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = FB_PO6_PIN;
  GPIO_Init(FB_PO6_GPIO_PORT, &GPIO_InitStructure);

  GPIO_WriteBit(POWER_ON_GPIO_PORT, POWER_ON_PIN, Bit_RESET);
  GPIO_WriteBit(FB_PO6_GPIO_PORT, FB_PO6_PIN, Bit_RESET);

}

void io_power_on(uint8_t value)
{
  if(value)
    GPIO_WriteBit(POWER_ON_GPIO_PORT, POWER_ON_PIN, Bit_SET);
  else
    GPIO_WriteBit(POWER_ON_GPIO_PORT, POWER_ON_PIN, Bit_RESET);
}

void io_po6(uint8_t value)
{
  if(value)
    GPIO_WriteBit(FB_PO6_GPIO_PORT, FB_PO6_PIN, Bit_SET);
  else
    GPIO_WriteBit(FB_PO6_GPIO_PORT, FB_PO6_PIN, Bit_RESET);
}

void poweron(void)
{
  io_power_on(1);
  io_po6(1);
}

void poweroff(void)
{
  io_power_on(0);
  io_po6(0);
}
